// Check if the element is an image
function PhotoMEContextPopupShowing()
{
	if (gContextMenu.onImage || gContextMenu.onStandaloneImage)
	{
		gContextMenu.showItem("photome", true);
		gContextMenu.showItem("photome_separator", true);
	}
	else
	{
		gContextMenu.showItem("photome", false);
		gContextMenu.showItem("photome_separator", false);
	}
}

var gStrBundle;

function OpenPhotoME(url)
{
	gStrBundle = document.getElementById("bundle_photome");

	var tmpfile;
	if (url)
	{
		var fu = new FileUtils();
		launchyShared.trace("URL <" + url + ">");
		if (launchyShared.isLinkType("file", url))
		{
			url = url.toString().replace(/[?#].*$/, "");

			launchyShared.trace("URL local <" + url + ">");
			tmpfile = "file:///" + fu.urlToPath(url);
		}
		else
		{
			try
			{
				var d = new Date().getTime();
				var du = new DirUtils();
				var tmpFileName = "photome-" + d;
				var typePos = url.lastIndexOf(".");
				if ( typePos != -1 )	tmpFileName += url.substr(typePos);
				tmpfile = fu.append(du.getTmpDir(), tmpFileName);
				launchyShared.trace("Temporary file <" + tmpfile + ">");

				var f = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				f.initWithPath(tmpfile);

				const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
				var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(nsIWBP);
				persist.persistFlags = nsIWBP.PERSIST_FLAGS_FROM_CACHE | nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | nsIWBP.PERSIST_FLAGS_DONT_CHANGE_FILENAMES;

				var URI = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
				URI.spec = url;

				launchyShared.trace("Trying to save URL <" + url + ">");

				persist.saveURI(URI, null, null, null, null, f);
		
				tmpfile = "file:///" + tmpfile;
			}
			catch (ex)
			{
				// ΪļܸߣֱӴز鿴Ϣ
				launchyShared.trace("Cannot save URL <" + url + "> due to:\n" + ex);
				tmpfile = url;
			}
		}

		var app_exe = GetAppPath("SOFTWARE\\bkViewer\\bkViewer\\bkViewer", "");

		var args = new Array;
		args[0] = tmpfile;

		launchyShared.trace("About to run:\n" + app_exe + " " + args);

		try
		{
			fu.spawn(app_exe, args);
		}
		catch(ex)
		{
			launchyShared.trace("bkViewer could not be found.");
			alert(gStrBundle.getString("PhotoMeNotFound"));
		}
	}
	else
	{
		launchyShared.trace("Unable to get URL");
		alert(gStrBundle.getString("UnableToGetUrl"));
	}
}

function GetAppPath(SubKey, ValueName)
{
	var winhooks;
	if ("@mozilla.org/windows-registry-key;1" in Components.classes)
	{
		try
		{
			winhooks = Components.classes["@mozilla.org/windows-registry-key;1"].getService(Components.interfaces.nsIWindowsRegKey);
		}
		catch(ex)
		{
			launchyShared.trace("Unable to get windows-registry-key service!");
		}

		if (typeof(winhooks) == "undefined"	|| typeof(winhooks.open) != "function")
		{
			winhooks = false;
			launchyShared.trace("nsIWindowsRegKey:open isn't available. This only works on Windows!");
			alert(gStrBundle.getString("nsIWindowsRegKeyOpenNotAvailable"));

			return "";
		}
	}
	else if ("@mozilla.org/winhooks;1" in Components.classes)
	{
		try
		{
			winhooks = Components.classes["@mozilla.org/winhooks;1"].getService(Components.interfaces.nsIWindowsRegistry);
		}
		catch(ex)
		{
			launchyShared.trace("Unable to get winhooks service!");
		}

		if (typeof(winhooks) == "undefined" || typeof(winhooks.getRegistryEntry) != "function")
		{
			winhooks = false;
			launchyShared.trace("getRegistryEntry isn't available. This only works on Windows!");
			alert(gStrBundle.getString("getRegistryEntryNotAvailable"));

			return "";
		}
	}
	else if ("@mozilla.org/browser/shell-service;1" in Components.classes)
	{
		try
		{
			winhooks = Components.classes["@mozilla.org/browser/shell-service;1"].getService(Components.interfaces.nsIWindowsShellService);
		}
		catch(ex)
		{
			launchyShared.trace("Unable to get browser shell service!");
		}

		if (typeof(winhooks) == "undefined" || typeof(winhooks.getRegistryEntry) != "function")
		{
			winhooks = false;
			launchyShared.trace("getRegistryEntry isn't available. This only works on Windows!");
			alert(gStrBundle.getString("getRegistryEntryNotAvailable"));

			return "";
		}
	}
	else
	{
		launchyShared.trace("Unable to get Components. This only works on Windows!");
		alert(gStrBundle.getString("UnableToGetComponents"));
		return "";
	}

	if(winhooks)
	{
		try
		{
			if(typeof(winhooks.open) != "function")
			{
				// 3 = HKEY_LOCAL_MACHINE
				// 2 = HKEY_CURRENT_USER
				var strApp = winhooks.getRegistryEntry("2", SubKey, ValueName);

				return strApp;
			}
			else
			{
				winhooks.open(Components.interfaces.nsIWindowsRegKey.ROOT_KEY_CURRENT_USER, SubKey, Components.interfaces.nsIWindowsRegKey.ACCESS_READ);
				var strApp = winhooks.readStringValue(ValueName);

				return strApp;
			}
		}
		catch(ex)
		{
			return "";
		}
	}
	else
	{
		return "";
	}
}

function InitPhotoMEOverlay()
{
	CleanTempFile();

	document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", PhotoMEContextPopupShowing, false);
}

function CleanTempFile()
{
	var du = new DirUtils();
	var contents = new Dir(du.getTmpDir()).readDir();
	var re = /^photome-(\d+)\./i;
	var u = new Date().getTime();

	for (var i = 0; i < contents.length; i++)
	{
		if (contents[i].isFile())
		{
			var x = contents[i].leaf.match(re);
			if (x && x[1])
			{
				if (u - parseInt(x[1]) > 60 * 60 * 24 * 1000)
				{
					launchyShared.trace("Deleting old view files <" + contents[i].path + ">");
					contents[i].remove();
				}
			}
		}
	}
}

window.addEventListener("load", InitPhotoMEOverlay, false);
